#!/usr/bin/bash

DRIVER=$1
LOG_FILE=$2
KEY=$3
PROG=$4

exec 2>&1
exec >>$LOG_FILE

SCRIPT_DIR=`dirname $0`
. ${SCRIPT_DIR}/set.sh || exit 1

RUN_SCRIPT=`mktemp /tmp/drv_installXXXXX.sh`
chmod 755 $RUN_SCRIPT

SLEEP_SEC=1

case $DRIVER in
	'kmod-nvidia')
		cat >$RUN_SCRIPT <<EOF
#!/bin/bash
dnf -y install kmod-nvidia --refresh
EOF
;;
	'kmod-stk83xx')
		cat >$RUN_SCRIPT <<EOF
#!/bin/bash
dnf -y install kmod-stk83xx --refresh
EOF
;;
	'akmod-nvidia') 
	SLEEP_SEC=2
	cat >$RUN_SCRIPT <<EOF
#!/bin/bash
dnf -y install akmod-nvidia --refresh || exit 1
systemctl enable --now akmods || exit 1
# always run akmods and dracut at the end of updates
akmods  || exit 1
dracut -f --regenerate-all 
EOF
	;;
	'akmod-stk83xx') 
	SLEEP_SEC=2
	cat >$RUN_SCRIPT <<EOF
#!/bin/bash
dnf -y install akmod-stk83xx --refresh || exit 1
systemctl enable --now akmods || exit 1
# always run akmods and dracut at the end of updates
akmods  || exit 1
dracut -f --regenerate-all 
EOF
	;;

	'alsa-firmware') 
cat >$RUN_SCRIPT <<EOF
#!/bin/bash

dnf -y install alsa-firmware
sleep 5
exit 0
EOF
	;;
	*) exit ;;
esac

${SCRIPT_DIR}/yad_progress.sh "$INST_DRV_MESS" $YAD_PROGRESS_PID_FILE 100 $SLEEP_SEC
pkexec $RUN_SCRIPT
RCODE=$?
kill `cat $YAD_PROGRESS_PID_FILE`
rm $YAD_PROGRESS_PID_FILE
rm $RUN_SCRIPT
if [ $RCODE -eq 0 ]; then
	yad $YAD_OPT --title="$YAD_TITLE" --text "$DRV_INSTALL_OK_MESS" --button "$RESTART_MESS":1 --button "$RESTART_LATER_MESS":2
else
	yad $YAD_OPT --title="$YAD_TITLE" --text "$DRV_INSTALL_ERR_MESS \nLog file: $LOG_FILE" --button "$CLOSE_BUTTON_MESS":2
fi
Quit $?
